# Gargantext Purescript

## About this project

Gargantext is a collaborative web platform for the exploration of sets
of unstructured documents. It combines tools from natural language
processing, text-mining, complex networks analysis and interactive data
visualization to pave the way toward new kinds of interactions with your
digital corpora.

This program is free software, developed by the CNRS Complex Systems
Institute of Paris Île-de-France (ISC-PIF) and its partners.

## Development

### Dependencies

You will not find this very useful without also running or being
granted access to a [backend](https://gitlab.iscpif.fr/gargantext/haskell-gargantext)

Build tools:

1. [yarn](https://yarnpkg.com/en/). [install instructions](https://yarnpkg.com/en/docs/install)

Javascript and Purescript dependencies:

```shell
yarn install && yarn ps-deps
```

### Running a dev server

```shell
yarn dev
```

This will launch a hot-reloading development server with
webpack-dev-server.  Visit [localhost:9000](http://localhost:9000/) to
see the result when the output shows a line like this:

```
ℹ ｢wdm｣: Compiled successfully.
```

#### Purescript IDE integration

A `purs ide` connection will be available on port 9002 while the
development server is running.

A guide to getting set up with the IDE integration is beyond the scope
of this document.

#### Source maps

Currently broken. Someone please fix them.

### Getting a purescript repl

```shell
yarn repl
```

### Building for production

```shell
yarn build
```

Note that a production build takes a little while.

### How do I?

#### Change which backend to connect to?

Edit `Config.purs`. Find the function `endConfig'` just after the
imports and edit `back`. The definitions are not far below, just after
the definitions of the various `front` options.

Example (using `demo.gargantext.org` as backend):

```
endConfig' :: ApiVersion -> EndConfig
endConfig' v = { front : frontRelative
               , back  : backDemo v  }
```

### Contributor notes

Please follow CONTRIBUTING.md
